      program exactsolution
      implicit real*8 (a-h,o-z)
C nx : the same value of nx in hd1d-roe.f
C tend : the same value of tend in hd1d-roe.f
C gamma : the same value of gamma in hd1d-roe.f
      nx=100
      tend=14.40d0
      gamma=1.40d0
      write(6,*)  'nx=',nx,'  tend=',tend,'  gamma=',gamma
      call sod(nx,gamma,tend)
      stop
      end

      subroutine sod(nx,gamma,tend)
      implicit real*8 (a-h,o-z)
      parameter(n=100)
      parameter(ng=5+n+1+1)

      parameter(epsin=1.0d-3,epsq=1.0d-6)
      dimension gx(ng),gr(ng),gp(ng),gu(ng)

      fp2p1(gamma,c1c4,ap,p2p1)=
     $  1.0d0/ap/p2p1*(1.0d0-((gamma-1.0d0)/2.0d0*c1c4*
     $  (p2p1-1.0d0)*dsqrt(
     $  2.0d0/gamma/((gamma+1.0d0)*p2p1+gamma-1.0d0))))
     $  **(2.0d0*gamma/(gamma-1.0d0))-1.0d0

      data r4,p4,u1,u4/
     $  1.0d0,1.0d0,0.0d0,0.0d0/


      xin=0.50d0

      ar=0.1250d0
      ap=0.10d0

      r1=ar*r4
      p1=ap*p4

      tf=tend/dble(nx)

      c1c4=dsqrt(ap/ar)

      i=0
      qa=1.0d0+epsin
      qb=p4/p1-epsin
      qm=(qa+qb)/2.0d0
 10   continue
      ba=fp2p1(gamma,c1c4,ap,qa)
      bb=fp2p1(gamma,c1c4,ap,qb)
      bm=fp2p1(gamma,c1c4,ap,qm)
      if (ba*bb.gt.0.0d0) then
        write(6,'(''# no solution (step : '',i3,'') '')')
     $    i
        stop
      endif
      if (ba*bm.lt.0.0d0) then
        qb=qm
      else
        qa=qm
      endif
      qm=(qa+qb)/2.0d0
      i=i+1
      if ((qm-qa)/qm.lt.epsq) then
        goto 20
      endif
      goto 10
 20   continue
      p2p1=qm

      c1=dsqrt(gamma*p1/r1)
      u2=c1*(p2p1-1.0d0)*dsqrt(
     $  2.0d0/gamma/((gamma+1.0d0)*p2p1+gamma-1.0d0))

      us=c1*dsqrt(
     $  (gamma-1.0d0)/2.0d0/gamma+
     $  (gamma+1.0d0)/2.0d0/gamma*p2p1)
      r2=r1*us/(us-u2)

      p2=p2p1*p1

      xs=xin+us*tf

      u3=u2
      p3=p2
      r3=r4*(p3/p4)**(1.0d0/gamma)

      x11=1.0d0
      x12=xs
      x23=xin+u2*tf
      x44=0.0d0

      c3=dsqrt(gamma*p3/r3)
      c4=c1/c1c4
      h3=2.0d0*c4/(gamma-1.0d0)-(gamma+1.0d0)/(gamma-1.0d0)*c3
      h4=2.0d0*c4/(gamma-1.0d0)-(gamma+1.0d0)/(gamma-1.0d0)*c4
      
      gx(1)=x11
      gx(2)=x12
      gx(3)=x12
      gx(4)=x23
      gx(5)=x23
      gr(1)=r1
      gr(2)=r1
      gr(3)=r2
      gr(4)=r2
      gr(5)=r3
      gp(1)=p1
      gp(2)=p1
      gp(3)=p2
      gp(4)=p2
      gp(5)=p3
      gu(1)=u1
      gu(2)=u1
      gu(3)=u2
      gu(4)=u2
      gu(5)=u3
      j=6
      do 100 i=0,n
        h=h3+(h4-h3)/dble(n)*dble(i)
        x=xin+h*tf
        c=(gamma-1.0d0)/(gamma+1.0d0)*(
     $    2.0d0*c4/(gamma-1.0d0)-h)
        u=c+h
        r=(c*c/gamma)**(1.0d0/(gamma-1.0d0))
        p=r**gamma
        gx(j)=x
        gr(j)=r
        gp(j)=p
        gu(j)=u
        j=j+1
 100  continue
      gx(j)=x44
      gr(j)=r4
      gp(j)=p4
      gu(j)=u4

      open(10,file='sod.d',form='formatted',status='unknown')
      write(10,'(''#'',A11,1x,3(A12:1x))') 'x','rho','u','p'
      do i=1,5+n+1+1
        write(10,'(4(1pe12.5:1x))')
     $    gx(i)*dble(nx),gr(i),gu(i),gp(i)
      enddo
      close(10)

      return
      end
