CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine roeaverage(rl,ul,hl,rr,ur,hr,au,ah)
      implicit real*8 (a-h,o-z)
      sqrl=dsqrt(rl)
      sqrr=dsqrt(rr)
      au=(sqrl*ul+sqrr*ur)/(sqrl+sqrr)
      ah=(sqrl*hl+sqrr*hr)/(sqrl+sqrr)
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine fluxatmesh(rho,u,p,e,f)
      implicit real*8 (a-h,o-z)
      dimension f(3)
      f(1)=rho*u
      f(2)=rho*u**2+p
      f(3)=(e+p)*u
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine fluxabsA(rm,sl,sr,rl,ul,el,cl,rr,ur,er,cr,fa)
      implicit real*8 (a-h,o-z)
      dimension rm(3),sr(3,3),sl(3,3),fa(3)
      dimension dq(3)
      dimension absrmmod(3)

      dq(1)=rr-rl
      dq(2)=rr*ur-rl*ul
      dq(3)=er-el
      call fancorrect(ul,ur,cl,cr,rm,absrmmod)
      do i=1,3
        fa(i)=0.0d0
        do j=1,3
          do k=1,3
            fa(i)=fa(i)+sr(i,j)*absrmmod(j)*sl(j,k)*dq(k)
          enddo
        enddo
      enddo
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine fancorrect(ul,ur,cl,cr,rm,absrmmod)
      implicit real*8 (a-h,o-z)
      dimension rm(3),absrmmod(3), rml(3),rmr(3)
      rml(1)=ul-cl
      rml(2)=ul
      rml(3)=ul+cl
      rmr(1)=ur-cr
      rmr(2)=ur
      rmr(3)=ur+cr
      do j=1,3
        if (rml(j).lt.0.0d0.and.0.0d0.lt.rmr(j)) then
          absrmmod(j)=dabs(rm(j))+(rmr(j)-rml(j))/2.0d0
        else
          absrmmod(j)=dabs(rm(j))
        endif
      enddo
      return
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine muscl(nx,gamma,q,qt,ql,qr)
      implicit real*8 (a-h,o-z)
      dimension q(3,0:nx),qt(3,0:nx),ql(3,nx),qr(3,nx)
      dimension rm(3),sr(3,3),sl(3,3)
      dimension dqm(3),dqp(3)
      dimension alpm(3),alpp(3),alpl(3),alpr(3)
      common /flag/imuscl, imusclsuperbee, ico, icosuperbee

      fminmod(a,b)=dsign(1.0d0,a)*
     $  max(0.0d0,min(dabs(a),dsign(1.0d0,a)*b))
      fsuperbee(a,b,w)=dsign(1.0d0,a)*
     $  max(0.0d0,min(w*dsign(1.0d0,a)*b,dabs(a)),
     $  min(dsign(1.0d0,a)*b,w*dabs(a)))

      gam1=gamma-1.0d0
      isuperbee=imusclsuperbee
      xi=1.0d0/3.0d0
      if (isuperbee.eq.1) then
        wcomp=2.0d0
      else
        wcomp=(3.0d0-xi)/(1.0d0-xi)
      endif
      do i=1,nx-1
        do j=1,3
          dqm(j)=q(j,i)-q(j,i-1)
          dqp(j)=q(j,i+1)-q(j,i)
        enddo
        call variables(nx+1,i+1,q,gamma,r0,u0,e0,p0,h0)
        call makematrix(gam1,u0,h0,sl,sr,rm)
        do j=1,3
          alpm(j)=0.0d0
          alpp(j)=0.0d0
          do k=1,3
            alpm(j)=alpm(j)+sl(j,k)*dqm(k)
            alpp(j)=alpp(j)+sl(j,k)*dqp(k)
          enddo
          if (isuperbee.eq.0) then
            alpr(j)=fminmod(alpp(j),wcomp*alpm(j))
            alpl(j)=fminmod(alpm(j),wcomp*alpp(j))
          else
            alpr(j)=fsuperbee(alpp(j),alpm(j),wcomp)
            alpl(j)=fsuperbee(alpm(j),alpp(j),wcomp)
          endif
        enddo
        do j=1,3
          qr(j,i)=qt(j,i)
          ql(j,i+1)=qt(j,i)
          do k=1,3
            qr(j,i)=qr(j,i)
     $        -sr(j,k)
     $        *((1.0d0-xi)*alpr(k)+(1.0d0+xi)*alpl(k))/4.0d0
            ql(j,i+1)=ql(j,i+1)
     $        +sr(j,k)
     $        *((1.0d0-xi)*alpl(k)+(1.0d0+xi)*alpr(k))/4.0d0
          enddo
        enddo
      enddo
C boundary : ql(1), qr(nx)
      do j=1,3
        ql(j,1)=qt(j,0)
        qr(j,nx)=qt(j,nx)
      enddo
      return
      end
      
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine coscheme(nx,i,ql,qr,sl,sr,rm,flxco)
      implicit real*8 (a-h,o-z)
      dimension ql(3,nx),qr(3,nx),flxco(3,nx)
      dimension rm(3),sr(3,3),sl(3,3)
      dimension dqm(3),dq(3),dqp(3),alpm(3),alp(3),alpp(3)
      common /flag/imuscl, imusclsuperbee, ico, icosuperbee

      fminmod(a,b)=dsign(1.0d0,a)*
     $  max(0.0d0,min(dabs(a),dsign(1.0d0,a)*b))
      fsuperbee(a,b,w)=dsign(1.0d0,a)*
     $  max(0.0d0,min(w*dsign(1.0d0,a)*b,dabs(a)),
     $  min(dsign(1.0d0,a)*b,w*dabs(a)))

      isuperbee=icosuperbee
      xi=1.0d0/3.0d0
      if (isuperbee.eq.1) then
        wcomp=2.0d0
      else
        wcomp=(3.0d0-xi)/(1.0d0-xi)
      endif
      if (i.eq.1) then
        im=1
      else
        im=i-1
      endif
      if (i.eq.nx) then
        ip=nx
      else
        ip=i+1
      endif
      do j=1,3
        dqm(j)=qr(j,im)-ql(j,im)
        dq(j)=qr(j,i)-ql(j,i)
        dqp(j)=qr(j,ip)-ql(j,ip)
      enddo
      do j=1,3
        alpm(j)=0.0d0
        alp(j)=0.0d0
        alpp(j)=0.0d0
        do k=1,3
          alpm(j)=alpm(j)+sl(j,k)*dqm(k)
          alp(j)= alp(j) +sl(j,k)*dq(k)
          alpp(j)=alpp(j)+sl(j,k)*dqp(k)
        enddo
      enddo
      do k=1,3
        flxco(k,i)=0.0d0
        do j=1,3
          if (isuperbee.eq.0) then
            dsigmr=fminmod(alpp(j)*(rm(j)-dabs(rm(j))),
     $        wcomp*alp(j)*(rm(j)-dabs(rm(j))))/2.0d0
            dsigm=fminmod(alp(j)*(rm(j)-dabs(rm(j))),
     $        wcomp*alpp(j)*(rm(j)-dabs(rm(j))))/2.0d0
            dsigp=fminmod(alp(j)*(rm(j)+dabs(rm(j))),
     $        wcomp*alpm(j)*(rm(j)+dabs(rm(j))))/2.0d0
            dsigpl=fminmod(alpm(j)*(rm(j)+dabs(rm(j))),
     $        wcomp*alp(j)*(rm(j)+dabs(rm(j))))/2.0d0
          else
            dsigmr=fsuperbee(alpp(j)*(rm(j)-dabs(rm(j))),
     $        alp(j)*(rm(j)-dabs(rm(j))),wcomp)/2.0d0
            dsigm=fsuperbee(alp(j)*(rm(j)-dabs(rm(j))),
     $        alpp(j)*(rm(j)-dabs(rm(j))),wcomp)/2.0d0
            dsigp=fsuperbee(alp(j)*(rm(j)+dabs(rm(j))),
     $        alpm(j)*(rm(j)+dabs(rm(j))),wcomp)/2.0d0
            dsigpl=fsuperbee(alpm(j)*(rm(j)+dabs(rm(j))),
     $          alp(j)*(rm(j)+dabs(rm(j))),wcomp)/2.0d0
          endif
          flxco(k,i)=flxco(k,i)-
     $      ((1.0d0-xi)*dsigmr
     $      +(1.0d0+xi)*dsigm
     $      -(1.0d0+xi)*dsigp
     $      -(1.0d0-xi)*dsigpl)*sr(k,j)/4.0d0
        enddo
      enddo
      return
      end
